;;; "clp-ga-pool.scm"

;;; ===== POOL =====
; Erzeugen des POOLS.
; Es werden n verschiedene zufllig gefllte Containerlisten erzeugt.
(define
  (erzeuge-pool container-liste n)
  (cond
    ((positive? n)
     (cons
      (erzeuge-pool-element
       (umbau ; verndert die stueckeliste
        (cdar container-liste)
        (random (length (cdar container-liste)))
        '()) ; da endrekursiv !
       (cdr container-liste)
       '()) ; da endrekursiv !
      (erzeuge-pool container-liste (sub1 n))))
    (else  '())))

;;; ----- umbau -----
; die Liste der vorhandenen Stcke wird an der bergebenen stelle auseinander
; geschnitten und wieder zusammengesetzt. Reihenfolge z.T. gendert.
(define
  (umbau stuecke stelle akku)
  (cond
    ((null? stuecke) akku)
    ((zero? stelle)
     (append stuecke akku))
    (else
     (umbau (cdr stuecke) (sub1 stelle) (cons (car stuecke) akku)))))

;;; ----- erzeuge-pool-element -----
; Aus der Stckeliste werden in jeden Container gerade soviel Stcke getan
; bis er nicht berfllt ist.
; Achtung: die Containerliste enthlt hier nur die tatschlichen Container! 
(define
  (erzeuge-pool-element stuecke-liste container-liste akku)
  (cond
    ((null? container-liste) ; fertig, noch restliche Stcke davor!
     (cons
      (cons 0 stuecke-liste)
      (reverse akku)))
    ((null? stuecke-liste) ; sollte nicht sein, keine Stcke mehr!
     (cons
      (cons 0 stuecke-liste)
      (reverse akku)))
    ((>                     ; zu viel?
      (apply + (cons (car stuecke-liste) (cdar container-liste)))
      (caar container-liste))
     (erzeuge-pool-element
      stuecke-liste
      (cdr container-liste)
      (cons (car container-liste) akku)))
    (else                   ; rein das Stck!
     (erzeuge-pool-element
      (cdr stuecke-liste)
      (cons
       (cons
        (caar container-liste) ; Fassung
        (cons
         (car stuecke-liste)
         (cdar container-liste)))  ; mit Stck
       (cdr container-liste))
      akku))))
;;; ----- Test -----
;(erzeuge-pool *Container* 1)
