;;; "clp-ga-projekt.scm"
; Neue Modellierung fr das CLP mit Genetischen Algorithmen
; Vorgegeben ist eine Liste mit Containern und eine Liste mit Stcken
; berschreitungen werden akzeptiert, allerdings mit mehrfachem Gewicht
; als malus bewertet.
; Die nicht eingebauten Stcke liegen dazu in einem "Container" 
; mit dem Fassungsvermgen 0.
 (require (lib "breakpoint.ss"))
;;; Die vorliegende Lsung weicht dadurch von der Standardlsung ab, dass
;;; keine Individuen untereinander "Gene" austauschen, sondern nur
;;; die Container eines (!) Individuums jeweils. Dadurch erspart man sich
;;; die Betrachtungen der Zulssigkeit. Der Pool ermglicht es aber, schnell
;;; ungnstige Vorgaben auszuschlieen.

(load "clp-ga-daten-2.scm")
(load "clp-ga-bewertung.scm")
(load "clp-ga-mutation.scm")
(load "clp-ga-selektion.scm")
(load "clp-ga-generation.scm")
(load "clp-ga-pool.scm")
(load "clp-ga-crossing-over.scm")

;;; ===== Test =====
; 620 ist maximum!
(let
    ((beste (car (bestimme-beste 1 (Generationen-folge (erzeuge-pool *Container* 20) 40) '() '()))))
  (display beste) (newline)
  (display (bewerte beste)) (newline))
